'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = container;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _getDisplayName = require('../utils/getDisplayName');

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

var _shallowEqual = require('../utils/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function container(specs) {
  return function (DecoratedComponent) {
    var _class, _temp, _initialiseProps;

    var displayName = 'AdrenalineContainer(' + (0, _getDisplayName2.default)(DecoratedComponent) + ')';

    (0, _invariant2.default)(specs !== null && specs !== undefined, displayName + ' requires configuration.');

    (0, _invariant2.default)(typeof specs.query === 'string', 'You have to define \'query\' as a string in ' + displayName + '.');

    (0, _invariant2.default)(!specs.variables || typeof specs.variables === 'function', 'You have to define \'variables\' as a function in ' + displayName + '.');

    function mapPropsToVariables(props) {
      return !!specs.variables ? specs.variables(props) : {};
    }

    return _temp = _class = function (_Component) {
      _inherits(_class, _Component);

      _createClass(_class, null, [{
        key: 'getSpecs',
        value: function getSpecs() {
          return specs;
        }
      }]);

      function _class(props, context) {
        _classCallCheck(this, _class);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(_class).call(this, props, context));

        _initialiseProps.call(_this);

        _this.state = {
          data: null,
          isFetching: true
        };
        return _this;
      }

      _createClass(_class, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          this.query();
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          if (!(0, _shallowEqual2.default)(this.props, nextProps)) {
            this.query(nextProps);
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _state = this.state;
          var data = _state.data;
          var isFetching = _state.isFetching;

          var variables = mapPropsToVariables(this.props);

          var dataOrDefault = !data ? {} : data;

          return _react2.default.createElement(DecoratedComponent, _extends({}, this.props, dataOrDefault, {
            isFetching: isFetching,
            mutate: this.mutate,
            variables: variables }));
        }
      }]);

      return _class;
    }(_react.Component), _class.displayName = displayName, _class.DecoratedComponent = DecoratedComponent, _class.contextTypes = {
      query: _react.PropTypes.func,
      mutate: _react.PropTypes.func
    }, _initialiseProps = function _initialiseProps() {
      var _this2 = this;

      this.query = function () {
        var props = arguments.length <= 0 || arguments[0] === undefined ? _this2.props : arguments[0];
        var query = specs.query;

        var variables = mapPropsToVariables(props);

        _this2.setState({ isFetching: true }, function () {
          _this2.context.query(query, variables).catch(function (err) {
            console.error(err); // eslint-disable-line
          }).then(function (data) {
            return _this2.setState({ data: data, isFetching: false });
          });
        });
      };

      this.mutate = function (_ref) {
        var _ref$mutation = _ref.mutation;
        var mutation = _ref$mutation === undefined ? '' : _ref$mutation;
        var _ref$variables = _ref.variables;
        var variables = _ref$variables === undefined ? {} : _ref$variables;
        var _ref$files = _ref.files;
        var files = _ref$files === undefined ? null : _ref$files;
        var _ref$invalidate = _ref.invalidate;
        var invalidate = _ref$invalidate === undefined ? true : _ref$invalidate;

        return _this2.context.mutate(mutation, variables, files).then(function () {
          if (invalidate) {
            _this2.query();
          }
        });
      };
    }, _temp;
  };
}
//# sourceMappingURL=container.js.map