'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = presenter;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _getDisplayName = require('../utils/getDisplayName');

var _getDisplayName2 = _interopRequireDefault(_getDisplayName);

var _isPlainObject = require('../utils/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function presenter(specs) {
  return function (DecoratedComponent) {
    var _class, _temp;

    var displayName = 'AdrenalinePresenter(' + (0, _getDisplayName2.default)(DecoratedComponent) + ')';

    (0, _invariant2.default)(specs.hasOwnProperty('fragments'), '%s have not fragments declared', displayName);

    var fragments = specs.fragments;


    (0, _invariant2.default)((0, _isPlainObject2.default)(fragments), 'Fragments have to be declared as object in %s', displayName);

    return _temp = _class = function (_Component) {
      _inherits(_class, _Component);

      function _class() {
        _classCallCheck(this, _class);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(_class).apply(this, arguments));
      }

      _createClass(_class, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(DecoratedComponent, this.props);
        }
      }], [{
        key: 'getFragment',
        value: function getFragment(key) {
          (0, _invariant2.default)(typeof key === 'string', 'You cant call getFragment(key: string) without string key in %s', displayName);

          (0, _invariant2.default)(fragments.hasOwnProperty(key), 'Component %s has no fragment %s', displayName, key);

          return fragments[key].replace(/\s+/g, ' ').replace('fragment', '...').trim();
        }
      }]);

      return _class;
    }(_react.Component), _class.displayName = displayName, _class.DecoratedComponent = DecoratedComponent, _temp;
  };
}
//# sourceMappingURL=presenter.js.map